// Very basic Karplus-Strong 

// based on this explanation http://sites.music.columbia.edu/cmc/MusicAndComputers/chapter4/04_09.php


#include <Adafruit_MCP4728.h>
#include <Wire.h>

Adafruit_MCP4728 mcp;

#define nsamp 128
#define dacmax 256

unsigned int phase;
unsigned int repeats;

void setup() {

  Serial.begin(115200);

  if (!mcp.begin(0x64)) {
    while (1) {
      delay(100);
    }
  }

  randomSeed(analogRead(A0));
  mcp.setSpeed(800000L);

  phase=0;
}

byte waveform[nsamp];


void pluck(){
  for (int i=0; i<nsamp; ++i){  
    waveform[i]=random(256);
  }
}

void loop() {
  byte s1, s2;
  int p0 = phase;
  s1 = waveform[phase];
  phase += 1;
  if( phase >= nsamp ) {
    phase = 0;
    repeats += 1;
  }
  s2 = waveform[phase];
  waveform[p0] = ( s1 & s2 ) + ((s1 ^ s2) >> 1);
  mcp.fastWrite(s1 << 4, 0, 0, 0);
  if( repeats > 100 ) {
     pluck();
     repeats = 0;
  }
}

